/**********************************************************
 * BWave Video Codec
 * bitstream management
 * Copyricht (c) 2004 by Thomas Bergwinkl
 **********************************************************/

#include "../global.h"



void bitstream_init(BITSTREAM *bits, void *data, int max) {
	bits->pos = 0;
	bits->max = max;
	bits->data = data;
}


void bitstream_set_bit(BITSTREAM *bits, int bit) {
	if(bit)
		bits->data[bits->pos>>3] |= 1<<(bits->pos&7);
	else
		bits->data[bits->pos>>3] &= ~(1<<(bits->pos&7));
	bits->pos++;
}


int bitstream_get_bit(BITSTREAM *bits){
	int pos = bits->pos;
	bits->pos++;
	return (bits->data[pos>>3]>>(pos&7))&1;
}


void bitstream_set_bits(BITSTREAM *bits, uint32_t bit, int size) {
	for(size--; size!=-1; size--)
		bitstream_set_bit(bits, (bit>>size)&1);
}


uint32_t bitstream_get_bits(BITSTREAM *bits, int size) {
	uint32_t bit = 0;
	for(; size; size--)
		bit = (bit<<1) | bitstream_get_bit(bits);
	return bit;
}

