/**********************************************************
 * BWave Video Codec
 * compression
 * Copyricht (c) 2004 by Thomas Bergwinkl
 **********************************************************/

#include "../global.h"

void encode_uiv(BITSTREAM *bits, uint32_t value) {
	int k=0;
	
	while(value >= (1<<k)) {
		value -= 1<<k;
		k++;
	}
	
	bitstream_set_bits(bits, 0xFFFFFFFF, k);
	bitstream_set_bit(bits, 0);
	bitstream_set_bits(bits, value, k);
}


void encode_iv(BITSTREAM *bits, int32_t value) {
	encode_uiv(bits, ABS(value));
	if(value) {
		if(value < 0)
			bitstream_set_bit(bits, 1);
		else
			bitstream_set_bit(bits, 0);
	}
}


uint32_t decode_uiv(BITSTREAM *bits) {
	uint32_t value=0, k=0;
	
	while(bitstream_get_bit(bits))
		value += (1<<(k++));
	value += bitstream_get_bits(bits, k);
	
	return value;
}


int32_t decode_iv(BITSTREAM *bits) {
	uint32_t value;
	
	value = decode_uiv(bits);
	if(value)
		if(bitstream_get_bit(bits))
			value = -value;
		
	return value;
}
