/**********************************************************
 * BWave Video Codec
 * decoder
 * Copyricht (c) 2004 by Thomas Bergwinkl
 **********************************************************/

#include "global.h"


void decore_create(BW_DEC_PARAM *param) {
	BW_DEC_HANDLE *handle;

	cpu_init();

	handle = (BW_DEC_HANDLE*)bw_malloc(sizeof(BW_DEC_HANDLE));
	
	handle->width = param->width;
	handle->height = param->height;
	colorspace_init();
	image_create(&handle->cur_img, handle->width, handle->height);
	wl_image_create(&handle->wl_img, handle->width, handle->height);
	
	param->handle = (void*)handle;
}


void decore_decode(BW_DEC_HANDLE *handle, BW_DEC_FRAME *frame) {
	BITSTREAM bits;

	bitstream_init(&bits, frame->data, frame->size);
	
	decode_wl_image(&bits, &handle->wl_img);
	
	wl_image_iwt(&handle->wl_img);
	
	wl_image_export(&handle->wl_img, &handle->cur_img);

	image_export(&handle->cur_img, frame->image, frame->stride,
		frame->colorspace);

	emms();
}


void decore_destroy(BW_DEC_HANDLE *handle) {
	wl_image_destroy(&handle->wl_img);
	image_destroy(&handle->cur_img);
	bw_free(handle);
}

