/**********************************************************
 * BWave Video Codec
 * encoder
 * Copyricht (c) 2004 by Thomas Bergwinkl
 **********************************************************/

#include "global.h"


void encore_create(BW_ENC_PARAM *param) {
	BW_ENC_HANDLE *handle;

	cpu_init();

	handle = (BW_ENC_HANDLE*)bw_malloc(sizeof(BW_ENC_HANDLE));
	
	handle->frame_cnt = 0;
	handle->width = param->width;
	handle->height = param->height;
	colorspace_init();
	image_create(&handle->cur_img, handle->width, handle->height);
	wl_image_create(&handle->wl_img, handle->width, handle->height);

	param->handle = (void*)handle;
}


void encore_encode(BW_ENC_HANDLE *handle, BW_ENC_FRAME *frame) {
	BITSTREAM bits;

	bitstream_init(&bits, frame->data, frame->size);

	image_import(&handle->cur_img, frame->image, frame->stride,
		frame->colorspace);

	wl_image_import(&handle->wl_img, &handle->cur_img);
	wl_image_set_quant(&handle->wl_img, frame->quant, frame->deadz);
	wl_image_fwt(&handle->wl_img);

	encode_wl_image(&bits, &handle->wl_img);
	
	handle->frame_cnt++;
	
	frame->size = (bits.pos+7)>>3;

	emms();
}


void encore_destroy(BW_ENC_HANDLE *handle) {
	wl_image_destroy(&handle->wl_img);
	image_destroy(&handle->cur_img);
	bw_free(handle);
}

