/**********************************************************
 * BWave Video Codec
 * image management header file
 * Copyricht (c) 2004 by Thomas Bergwinkl
 **********************************************************/

#ifndef __IMAGE_H__
#define __IMAGE_H__


typedef struct {
	int width;
	int height;
	int stride_y;
	int stride_uv;
	uint8_t *y;
	uint8_t *u;
	uint8_t *v;
} IMAGE;


void image_create(IMAGE *image, int width, int height);
void image_destroy(IMAGE *image);
void image_import(IMAGE *image, void *data, int stride, int colorspace);
void image_export(IMAGE *image, void *data, int stride, int colorspace);


#endif /*__IMAGE_H__*/
