/**********************************************************
 * BWave Video Codec
 * API header file
 * Copyricht (c) 2004 by Thomas Bergwinkl
 **********************************************************/

#ifndef __LIBBW_H__
#define __LIBBW_H__

#define BW_VERSION 1

#define BW_COL_NULL 0
#define BW_COL_RGB24 1
#define BW_COL_YV12 2

/**********************************************************
 * Encoder
 **********************************************************/
#define BW_ENC_CREATE 1
#define BW_ENC_ENCODE 2
#define BW_ENC_DESTROY 3

void bw_encore(void *handle, int option, void *param);


typedef struct {
	int width;
	int height;
	void *handle;
} BW_ENC_PARAM;


typedef struct {
	void *image;
	int stride;
	int colorspace;
	int quant;
	int deadz;
	void *data;
	int size;

} BW_ENC_FRAME;


/**********************************************************
 * Decoder
 **********************************************************/
#define BW_DEC_CREATE 1
#define BW_DEC_DECODE 2
#define BW_DEC_DESTROY 3

void bw_decore(void *handle, int option, void *param);


typedef struct {
	int width;
	int height;
	void *handle;
} BW_DEC_PARAM;


typedef struct {
	void *data;
	int size;
	void *image;
	int stride;
	int colorspace;
} BW_DEC_FRAME;


#endif /*__LIBBW_H__*/
