/**********************************************************
 * BWave Video Codec
 * memory management
 * Copyricht (c) 2004 by Thomas Bergwinkl
 **********************************************************/

#include "../global.h"


void *bw_malloc(uint32_t size) {
    uint8_t *mem, *tmp;

    if((tmp = (uint8_t*)malloc(size+MEM_ALIGN)) != NULL) {
        mem = (uint8_t*)(((int)(tmp+MEM_ALIGN-1)&(int)(~MEM_ALIGN-1)));
        if(mem == tmp)
			mem += MEM_ALIGN;
        mem[-1] = (uint8_t)(mem-tmp);

        return (void*)mem;
    }

    return NULL;
}


void *bw_calloc(uint32_t size) {
    void *mem = bw_malloc(size);

    memset(mem, 0, size);

    return mem;
}


void bw_free(void *mem) {
    uint8_t *tmp = (uint8_t*)mem;

    if(tmp)
		free(tmp-1);
}

