/**********************************************************
 * BWave Video Codec
 * wavelet transform high level header file
 * Copyricht (c) 2004 by Thomas Bergwinkl
 **********************************************************/

#ifndef __WAVELET_H__
#define __WAVELET_H__


typedef struct {
	int width;
	int height;
	int stride;
	int width_l;
	int height_l;
	int width_h;
	int height_h;
	int quant;
	int deadz;
	int16_t *ll;
	int16_t *hl;
	int16_t *lh;
	int16_t *hh;
} WL_LEVEL;


typedef struct {
	int width;
	int height;
	int stride_y;
	int stride_uv;
	int16_t *y;
	int16_t *u;
	int16_t *v;
	int levels;
	WL_LEVEL wl_level_y[16];
	WL_LEVEL wl_level_u[16];
	WL_LEVEL wl_level_v[16];
} WL_IMAGE;


void wl_image_create(WL_IMAGE *wl_image, int width, int height);
void wl_image_destroy(WL_IMAGE *wl_image);
void wl_image_set_quant(WL_IMAGE *wl_image, int quant, int deadz);
void wl_image_import(WL_IMAGE *wl_image, IMAGE *image);
void wl_image_export(WL_IMAGE *wl_image, IMAGE *image);
void wl_image_fwt(WL_IMAGE *wl_image);
void wl_image_iwt(WL_IMAGE *wl_image);

#endif /*__WAVELET_H__*/
