#ifndef __CODEC_H__
#define __CODEC_H__

#include <windows.h>
#include "vfw.h"
#include "../src/libbw.h"

#define FOURCC_BW00   mmioFOURCC('B','W','0','0')
#define FOURCC_YV12   mmioFOURCC('Y','V','1','2')

#define BW00_NAME_L   L"BW00"
#define BW00_DESC_L   L"BergWave"



typedef struct CODEC {
	BW_ENC_PARAM enc_param;
	BW_DEC_PARAM dec_param;
} CODEC;


LRESULT drv_open(ICOPEN *);
LRESULT drv_close(CODEC *);

LRESULT icm_getinfo(ICINFO *, LRESULT);
LRESULT icm_about(HWND);
LRESULT icm_configure(HWND);


LRESULT icm_compress_query(CODEC *, BITMAPINFO *, BITMAPINFO *);
LRESULT icm_compress_get_format(CODEC *, BITMAPINFO *, BITMAPINFO *);
LRESULT icm_compress_get_size(CODEC *, BITMAPINFO *, BITMAPINFO *);
LRESULT icm_compress_frames_info(CODEC *, ICCOMPRESSFRAMES *);
LRESULT icm_compress_begin(CODEC *, BITMAPINFO *, BITMAPINFO *);
LRESULT icm_compress_end(CODEC *);
LRESULT icm_compress(CODEC *, ICCOMPRESS *);

LRESULT icm_decompress_query(CODEC *, BITMAPINFO *, BITMAPINFO *);
LRESULT icm_decompress_get_format(CODEC *, BITMAPINFO *, BITMAPINFO *);
LRESULT icm_decompress_begin(CODEC *, BITMAPINFO *, BITMAPINFO *);
LRESULT icm_decompress_end(CODEC *);
LRESULT icm_decompress(CODEC *, ICDECOMPRESS *);

#endif /*__CODEC_H__*/
