#include <windows.h>
#include "config.h"
#include "resource.h"

#define IsDlgChecked(hwnd,idc)	(IsDlgButtonChecked(hwnd,idc) == BST_CHECKED)
#define CheckDlg(hwnd,idc,value) CheckDlgButton(hwnd,idc, value?BST_CHECKED:BST_UNCHECKED)

void set_config() {
	HKEY hKey;

	if(RegOpenKeyEx(HKEY_CURRENT_USER, "Software\\GNU\\BergWave", 0, KEY_WRITE, &hKey) == ERROR_SUCCESS) {

		/* i frame quant */
		RegSetValueEx(hKey, "i_quant", 0, REG_DWORD, (CONST BYTE *)&config.i_quant, sizeof(config.i_quant));

		/* i frame deadzone */
		RegSetValueEx(hKey, "i_deadz", 0, REG_DWORD, (CONST BYTE *)&config.i_deadz, sizeof(config.i_deadz));

		/* p frame quant */
		RegSetValueEx(hKey, "p_quant", 0, REG_DWORD, (CONST BYTE *)&config.p_quant, sizeof(config.p_quant));

		/* p frame deadzone */
		RegSetValueEx(hKey, "p_deadz", 0, REG_DWORD, (CONST BYTE *)&config.p_deadz, sizeof(config.p_deadz));

		/* debugging active */
		RegSetValueEx(hKey, "d_active", 0, REG_DWORD, (CONST BYTE *)&config.d_active, sizeof(config.d_active));

		/* debug filename */
		RegSetValueEx(hKey, "d_filename", 0, REG_SZ, (CONST BYTE*)config.d_filename, strlen(config.d_filename));

		RegCloseKey(hKey);
	}
}


void get_config() {
	HKEY hKey;
	DWORD DataType, DataSize;

	if(RegOpenKeyEx(HKEY_CURRENT_USER, "Software\\GNU\\BergWave", 0, KEY_QUERY_VALUE, &hKey) == ERROR_SUCCESS) {
		
		/* i frame quant */
		RegQueryValueEx(hKey, "i_quant", NULL, &DataType, (LPBYTE)&config.i_quant, &DataSize);

		/* i frame deadzone */
		RegQueryValueEx(hKey, "i_deadz", NULL, &DataType, (LPBYTE)&config.i_deadz, &DataSize);

		/* p frame quant */
		RegQueryValueEx(hKey, "p_quant", NULL, &DataType, (LPBYTE)&config.p_quant, &DataSize);

		/* p frame deadzone */
		RegQueryValueEx(hKey, "p_deadz", NULL, &DataType, (LPBYTE)&config.p_deadz, &DataSize);

		/* debugging active */
		RegQueryValueEx(hKey, "d_active", NULL, &DataType, (LPBYTE)&config.d_active, &DataSize);

		/* debug filename */
		DataSize = MAX_PATH;
		RegQueryValueEx(hKey, "d_filename", NULL, &DataType, (LPBYTE)config.d_filename, &DataSize);

		RegCloseKey(hKey);
	}
}


int __stdcall ConfigProc(HWND hwndDlg, UINT uMsg, WPARAM wParam, LPARAM lParam) {
	switch(uMsg) {
		case WM_INITDIALOG: {
			/* i frame quant */
			SetDlgItemInt(hwndDlg, IDC_IQUANT, config.i_quant , FALSE);
			EnableWindow(GetDlgItem(hwndDlg, IDC_IQUANT), TRUE);

			/* i frame deadz */
			SetDlgItemInt(hwndDlg, IDC_IDEADZ, config.i_deadz , FALSE);
			EnableWindow(GetDlgItem(hwndDlg, IDC_IQUANT), TRUE);

			/* p frame quant */
			SetDlgItemInt(hwndDlg, IDC_PQUANT, config.p_quant , FALSE);
			EnableWindow(GetDlgItem(hwndDlg, IDC_PQUANT), TRUE);

			/* p frame deadz */
			SetDlgItemInt(hwndDlg, IDC_PDEADZ, config.p_deadz , FALSE);
			EnableWindow(GetDlgItem(hwndDlg, IDC_PQUANT), TRUE);

			/* debugging activ */
			CheckDlg(hwndDlg, IDC_DACTIVE, config.d_active);
			EnableWindow(GetDlgItem(hwndDlg, IDC_DACTIVE), TRUE);
			
			/* debug filename */
			SetDlgItemText(hwndDlg, IDC_DFILENAME, config.d_filename);
			EnableWindow(GetDlgItem(hwndDlg, IDC_DFILENAME), TRUE);

			return TRUE;
		}

		case WM_COMMAND:
			switch(LOWORD(wParam)) {
				
				case IDC_DFILENAME_BUTTON: {
					OPENFILENAME openfilename;
					char filename[MAX_PATH];

					GetDlgItemText(hwndDlg, IDC_DFILENAME, filename, MAX_PATH);

					memset(&openfilename, 0, sizeof(OPENFILENAME));
					openfilename.lStructSize = sizeof(OPENFILENAME);
					openfilename.hwndOwner = hwndDlg;
					openfilename.lpstrFilter = "debug text file (*.txt)\0*.txt\0All files (*.*)\0*.*\0\0";
					openfilename.lpstrFile = filename;
					openfilename.nMaxFile = MAX_PATH;
					openfilename.Flags = OFN_PATHMUSTEXIST | OFN_OVERWRITEPROMPT;

					if (GetSaveFileName(&openfilename)) {
				    	SetDlgItemText(hwndDlg, IDC_DFILENAME, filename);
                	}

                	return TRUE;
            	}
				
				case IDOK: {
					/* i frame quant */
					config.i_quant = GetDlgItemInt(hwndDlg, IDC_IQUANT, NULL, FALSE);

					/* i frame deadz */
					config.i_deadz = GetDlgItemInt(hwndDlg, IDC_IDEADZ, NULL, FALSE);

					/* p frame quant */
					config.p_quant = GetDlgItemInt(hwndDlg, IDC_PQUANT, NULL, FALSE);

					/* p frame deadz */
					config.p_deadz = GetDlgItemInt(hwndDlg, IDC_PDEADZ, NULL, FALSE);

					/* debugging activ */
					config.d_active = IsDlgChecked(hwndDlg, IDC_DACTIVE);

					/* debug filename */
					GetDlgItemText(hwndDlg, IDC_DFILENAME, config.d_filename, MAX_PATH);

					/* set reg config */
					set_config();

					EndDialog(hwndDlg,TRUE);

					return TRUE;
				}
			}

		default:
			return FALSE;
	}
}




int __stdcall AboutProc(HWND hwndDlg, UINT uMsg, WPARAM wParam, LPARAM lParam) {
	switch(uMsg) {
		case WM_INITDIALOG:
			return TRUE;

		case WM_COMMAND:
			switch(LOWORD(wParam)) {
				case IDOK:
					EndDialog(hwndDlg,TRUE);
					return TRUE;
			}

		default:
			return FALSE;
	}
}



   



