#include <windows.h>
#include "vfw.h"
#include "codec.h"
#include "config.h"




BOOL WINAPI DllMain(HANDLE hModule, DWORD ul_reason_for_call, LPVOID lpReserved) {
	hInst = (HINSTANCE)hModule;

	return TRUE;
}


/*__declspec(dllexport)*/ LRESULT WINAPI DriverProc(DWORD dwDriverId, HDRVR hDriver, UINT uMsg, LPARAM lParam1, LPARAM lParam2) {
	CODEC *codec = (CODEC*)dwDriverId;

	switch(uMsg) {
		case DRV_LOAD:
			return DRV_OK;

		case DRV_FREE:
			return DRV_OK;

		case DRV_OPEN:
			return drv_open((ICOPEN*)lParam2);

		case DRV_CLOSE:         
			return drv_close(codec);

		case DRV_DISABLE:
			return DRV_OK;

		case DRV_ENABLE:
			return DRV_OK;

		case DRV_INSTALL:
			return DRV_OK;

		case DRV_REMOVE:
			return DRV_OK;

		case DRV_QUERYCONFIGURE:
			return DRV_CANCEL;

		case DRV_CONFIGURE:
			return DRV_CANCEL;

		case ICM_GETINFO:
			return icm_getinfo((ICINFO*)lParam1, (LRESULT)lParam2);

		case ICM_ABOUT:
			return icm_about((HWND)lParam1);

		case ICM_CONFIGURE:
			return icm_configure((HWND)lParam1);

		case ICM_GETSTATE:
			return ICERR_OK;

		case ICM_SETSTATE:
			return ICERR_OK;

		case ICM_GET:
			return ICERR_OK;
     
		case ICM_SET:
			return ICERR_OK;

		case ICM_GETDEFAULTQUALITY:
			return ICERR_UNSUPPORTED;

		case ICM_GETQUALITY:
			return ICERR_UNSUPPORTED;

		case ICM_SETQUALITY:
			return ICERR_UNSUPPORTED;

		case ICM_GETBUFFERSWANTED:
			return ICERR_UNSUPPORTED;

		case ICM_GETDEFAULTKEYFRAMERATE:
			return ICERR_UNSUPPORTED;

		/* encoder */
		case ICM_COMPRESS_QUERY:
			return icm_compress_query(codec, (BITMAPINFO*)lParam1, (BITMAPINFO*)lParam2);

		case ICM_COMPRESS_GET_FORMAT:
			return icm_compress_get_format(codec, (BITMAPINFO*)lParam1, (BITMAPINFO*)lParam2);

		case ICM_COMPRESS_GET_SIZE:
			return icm_compress_get_size(codec, (BITMAPINFO*)lParam1, (BITMAPINFO*)lParam2);

		case ICM_COMPRESS_FRAMES_INFO:
			return icm_compress_frames_info(codec, (ICCOMPRESSFRAMES*)lParam1);

		case ICM_COMPRESS_BEGIN:
			return icm_compress_begin(codec, (BITMAPINFO*)lParam1, (BITMAPINFO*)lParam2);

		case ICM_COMPRESS_END:
			return icm_compress_end(codec);

		case ICM_COMPRESS:
			return icm_compress(codec, (ICCOMPRESS*)lParam1);

		/* decoder */
		case ICM_DECOMPRESS_QUERY:
			return icm_decompress_query(codec, (BITMAPINFO*)lParam1, (BITMAPINFO*)lParam2);

		case ICM_DECOMPRESS_GET_FORMAT:	
			return icm_decompress_get_format(codec, (BITMAPINFO*)lParam1, (BITMAPINFO*)lParam2);

		case ICM_DECOMPRESS_BEGIN:	
			return icm_decompress_begin(codec, (BITMAPINFO*)lParam1, (BITMAPINFO*)lParam2);

		case ICM_DECOMPRESS_END:	
			return icm_decompress_end(codec);

		case ICM_DECOMPRESS:
			return icm_decompress(codec, (ICDECOMPRESS*)lParam1);

		case ICM_DECOMPRESS_GET_PALETTE:
			return ICERR_UNSUPPORTED;

		case ICM_DECOMPRESS_SET_PALETTE:
			return ICERR_UNSUPPORTED;

		case ICM_DECOMPRESSEX_QUERY:
			return ICERR_UNSUPPORTED;

		case ICM_DECOMPRESSEX_BEGIN:
			return ICERR_UNSUPPORTED;

		case ICM_DECOMPRESSEX_END:
			return ICERR_UNSUPPORTED;

		case ICM_DECOMPRESSEX:
			return ICERR_UNSUPPORTED;

		default:
			if (uMsg < DRV_USER)
				return DefDriverProc(dwDriverId, hDriver, uMsg, lParam1, lParam2);
			else 
				return ICERR_UNSUPPORTED;
	}
}

void WINAPI Configure(HWND hwnd, HINSTANCE hinst, LPTSTR lpCmdLine, int nCmdShow) {
	DWORD dwDriverId;

	dwDriverId = DriverProc(0, 0, DRV_OPEN, 0, 0);
	if(dwDriverId != (DWORD)NULL) {
		DriverProc(dwDriverId, 0, ICM_CONFIGURE, 0, 0);
		DriverProc(dwDriverId, 0, DRV_CLOSE, 0, 0);
	}
}

